# Copyright 1999-2010 University of Chicago
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# 
package Globus::Core::Paths;

require Exporter;

@ISA = qw(Exporter);

@EXPORT = qw($exec_prefix $prefix
             $sbindir $bindir
             $libdir $libexecdir $includedir
             $flavorincludedir
             $datarootdir
             $mandir
             $datadir $sysconfdir $sharedstatedir
             $localstatedir);

sub eval_path
{
    my $path = shift;
    my $last = $path;

    while ($path =~ m/\$\{([^}]*)\}/)
    {
        my $varname = $1;
        my $evaluated;
        eval "\$evaluated = \${$1}";

        $path =~ s/\${$varname}/$evaluated/g;
        if ($path eq $last)
        {
            die "Error evaluating $last\n";
        }
        $last = $path;
    }
    return $path;
}

if (exists $ENV{GLOBUS_LOCATION})
{
    $prefix = $ENV{GLOBUS_LOCATION};
}
else
{
    $prefix = '/usr/i686-pc-mingw32/sys-root/mingw';
}
$exec_prefix = eval_path('/usr/i686-pc-mingw32/sys-root/mingw');
$sbindir = eval_path('/usr/i686-pc-mingw32/sys-root/mingw/sbin');
$bindir = eval_path('/usr/i686-pc-mingw32/sys-root/mingw/bin');
$libdir = eval_path('/usr/i686-pc-mingw32/sys-root/mingw/lib');
$includedir = eval_path('${prefix}/include/globus');
$datarootdir = eval_path('${prefix}/share');
$datadir = eval_path('/usr/i686-pc-mingw32/sys-root/mingw/share');
$mandir = eval_path('/usr/i686-pc-mingw32/sys-root/mingw/share/man');
$libexecdir = eval_path('${datadir}/globus');
$sysconfdir = eval_path('/usr/i686-pc-mingw32/sys-root/mingw/etc');
$sharedstatedir = eval_path('/usr/i686-pc-mingw32/sys-root/mingw/com');
$localstatedir = eval_path('/usr/i686-pc-mingw32/sys-root/mingw/var');
$flavorincludedir = eval_path('${libdir}/globus/include');

1;
